var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var Mode;
(function (Mode) {
    Mode[Mode["Inactive"] = 1] = "Inactive";
    Mode[Mode["CameraReady"] = 2] = "CameraReady";
    Mode[Mode["Countdown"] = 3] = "Countdown";
    Mode[Mode["TakingPicture"] = 4] = "TakingPicture";
    Mode[Mode["CheckingPicture"] = 5] = "CheckingPicture";
    Mode[Mode["Error"] = 6] = "Error";
    Mode[Mode["UserHappy"] = 7] = "UserHappy";
    Mode[Mode["UserUnhappy"] = 8] = "UserUnhappy";
})(Mode || (Mode = {}));
var SmileToUnlock = /** @class */ (function () {
    function SmileToUnlock() {
        this.apiUrl = "https://westus.api.cognitive.microsoft.com/emotion/v1.0/recognize";
    }
    SmileToUnlock.prototype.start = function () {
        this.init();
        this.startCamera();
        this.show();
    };
    SmileToUnlock.prototype.end = function () {
        this.hide();
        this.endCamera();
    };
    SmileToUnlock.prototype.hide = function () {
        this.el.style.display = "none";
    };
    SmileToUnlock.prototype.show = function () {
        this.el.style.display = "block";
    };
    SmileToUnlock.prototype.init = function () {
        this.state = Mode.Inactive; // This makes the overlay appear, once the video is setup the overlay with disappear
        this.video = this.el.querySelector("#video");
        this.canvas = this.el.querySelector("canvas");
    };
    SmileToUnlock.prototype.takeSnapshot = function () {
        var context = this.canvas.getContext("2d"), width = this.video.videoWidth, height = this.video.videoHeight;
        if (width && height) {
            // Setup a canvas with the same dimensions as the video.
            this.canvas.width = width;
            this.canvas.height = height;
            // Make a copy of the current frame in the video on the canvas.
            context.drawImage(this.video, 0, 0, width, height);
            this.calculateHappiness();
        }
    };
    SmileToUnlock.prototype.startCamera = function () {
        var _this = this;
        navigator.mediaDevices
            .getUserMedia({ video: true })
            .then(function (stream) {
            _this.video.src = window.URL.createObjectURL(stream);
            return _this.video.play();
        })
            .then(function (_) { return (_this.state = Mode.CameraReady); })
            .catch(function (err) {
            console.error(err);
            _this.state = Mode.Error;
            _this.errorMessage = "There was a problem starting your camera";
        });
    };
    SmileToUnlock.prototype.endCamera = function () {
        this.video.pause();
        this.video.src = "";
    };
    SmileToUnlock.prototype.startCountdown = function (event) {
        var _this = this;
        event.preventDefault();
        this.state = Mode.Countdown; // This shows the numbers
        this.countdown = 3; // XXX: Move to setting
        var refreshId = setInterval(function () {
            _this.countdown -= 1;
            if (_this.countdown === 0) {
                clearInterval(refreshId);
                // Show the flash animation, this takes 0.5s
                _this.state = Mode.TakingPicture;
                setTimeout(function () {
                    // 0.25s into the Flash (at the white peak) take the snapshot
                    _this.takeSnapshot();
                }, 250);
            }
        }, 1000);
    };
    SmileToUnlock.prototype.getImageBlob = function () {
        var _this = this;
        return new Promise(function (resolve) {
            _this.canvas.toBlob(function (blob) { return resolve(blob); });
        });
    };
    SmileToUnlock.prototype.calculateHappiness = function () {
        return __awaiter(this, void 0, void 0, function () {
            var blob, response, faces, face;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.state = Mode.CheckingPicture;
                        return [4 /*yield*/, this.getImageBlob()];
                    case 1:
                        blob = _a.sent();
                        return [4 /*yield*/, fetch(this.apiUrl, {
                                headers: {
                                    "Ocp-Apim-Subscription-Key": this.apiKey,
                                    "Content-Type": "application/octet-stream"
                                },
                                method: "POST",
                                body: blob
                            })];
                    case 2:
                        response = _a.sent();
                        return [4 /*yield*/, response.json()];
                    case 3:
                        faces = _a.sent();
                        if (faces.length > 0) {
                            face = faces[0];
                            this.happiness = face.scores.happiness;
                            console.debug(this.happiness);
                            this.state = this.isUserHappy ? Mode.UserHappy : Mode.UserUnhappy;
                        }
                        else {
                            // Handle when no faces or error returned
                            this.state = Mode.Error;
                            this.errorMessage = "You don't seem to have a face? Try again!";
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    SmileToUnlock.prototype.unlockContent = function () {
        // Don't hide yourself, let the outer component decide what to do.
        this.userSmiled.emit({ score: this.happiness });
    };
    SmileToUnlock.prototype.componentWillLoad = function () {
        if (!this.apiKey) {
            console.error("smile-to-unlock missing required attribute 'apiKey'");
            return false;
        }
    };
    Object.defineProperty(SmileToUnlock.prototype, "percentHappy", {
        get: function () {
            return Math.floor(this.happiness * 100);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SmileToUnlock.prototype, "isUserHappy", {
        get: function () {
            return this.happiness && this.happiness > 0.9;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SmileToUnlock.prototype, "showInactive", {
        get: function () {
            return this.state === Mode.Inactive;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SmileToUnlock.prototype, "showFlash", {
        get: function () {
            return this.state === Mode.TakingPicture;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SmileToUnlock.prototype, "showCamera", {
        get: function () {
            return (this.state === Mode.Inactive ||
                this.state === Mode.CameraReady ||
                this.state === Mode.Countdown ||
                this.state === Mode.TakingPicture ||
                this.state === Mode.Error);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SmileToUnlock.prototype, "showPicture", {
        get: function () {
            return (this.state === Mode.CheckingPicture ||
                this.state === Mode.UserHappy ||
                this.state === Mode.UserUnhappy);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SmileToUnlock.prototype, "emotionalDescription", {
        get: function () {
            if (this.happiness > 0.9) {
                return "(" + this.percentHappy + "% Happy) \uD83D\uDE01 There you go, wasn't so hard was it?";
            }
            else if (this.happiness > 0.6) {
                return "(" + this.percentHappy + "% Happy) \uD83D\uDE00 Almost, just a little more\u2026";
            }
            else if (this.happiness > 0.5) {
                return "(" + this.percentHappy + "% Happy) \uD83D\uDE42 Getting there\u2026 show me those teeth!";
            }
            else if (this.happiness > 0.3) {
                return "(" + this.percentHappy + "% Happy) \uD83D\uDE10 Well\u2026 at least it's not a frown";
            }
            else if (this.happiness > 0.2) {
                return "(" + this.percentHappy + "% Happy) \uD83D\uDE15 Maybe if you think of something funny?";
            }
            else if (this.happiness > 0.1) {
                return "(" + this.percentHappy + "% Happy) \uD83D\uDE41 It's not called 'frown to unlock'";
            }
            else if (this.happiness > 0.05) {
                return "(" + this.percentHappy + "% Happy) \u2639\uFE0F Do you even know what a smile is?";
            }
            else {
                return "(" + this.percentHappy + "% Happy) \uD83D\uDE2D Do you want a tissue?";
            }
        },
        enumerable: true,
        configurable: true
    });
    SmileToUnlock.prototype.render = function () {
        var _this = this;
        return (h("div", { "c": { "app": true } },
            h("div", { "c": { "controls": true } },
                h("div", { "c": { "header": true } },
                    h("span", { "c": { "promo": true } },
                        h("a", { "a": { "target": "_blank", "href": "https://smiletounlock.com/" } }, t("Smile to Unlock")), t(" | "),
                        h("a", { "a": { "target": "_blank", "href": "http://bit.ly/emotive-api-stu" } }, t("Powered by Azure"))),
                    h("a", { "c": { "icon": true }, "o": { "click": this.end.bind(this) }, "a": { "href": "#" } },
                        h("i", { "c": { "material-icons": true } }, t("close")))),
                (function () {
                    switch (_this.state) {
                        case Mode.CameraReady:
                            // This shows the instructions screen
                            return (h("div", { "c": { "message": true } },
                                h("span", 0, t("Smile and then press")),
                                h("span", { "c": { "arrow-icon": true } },
                                    h("i", { "c": { "material-icons": true } }, t("arrow_forward"))),
                                h("a", { "c": { "icon": true }, "o": { "click": _this.startCountdown.bind(_this) }, "a": { "href": "#" } },
                                    h("i", { "c": { "material-icons": true } }, t("camera_alt")))));
                        case Mode.Countdown:
                            // This shows the countdown screen
                            return [
                                h("div", { "c": { "message": true } },
                                    h("span", { "c": { "countdown": true } }, _this.countdown)),
                                h("div", { "c": { "spacer": true } }, t("\u00A0"))
                            ];
                        case Mode.CheckingPicture:
                            // This shows the detecting message
                            return (h("div", { "c": { "message": true } },
                                h("span", { "c": { "checking": true } }, t("Detecting happiness "),
                                    h("span", { "c": { "spinner": true } }))));
                        case Mode.Error:
                            // This shows the error message
                            return (h("div", { "c": { "message": true } },
                                h("span", { "c": { "arrow-icon": true } },
                                    h("i", { "c": { "material-icons": true } }, t("error_outline"))),
                                h("span", { "c": { "error": true } }, t("\u00A0"),
                                    _this.errorMessage),
                                h("span", { "c": { "arrow-icon": true } },
                                    h("i", { "c": { "material-icons": true } }, t("arrow_forward"))),
                                h("a", { "c": { "icon": true }, "o": { "click": _this.startCountdown.bind(_this) }, "a": { "href": "#" } },
                                    h("i", { "c": { "material-icons": true } }, t("camera_alt")))));
                        case Mode.UserUnhappy:
                            return (h("div", { "c": { "message": true } },
                                h("span", 0, _this.emotionalDescription),
                                h("span", { "c": { "arrow-icon": true } },
                                    h("i", { "c": { "material-icons": true } }, t("arrow_forward"))),
                                h("a", { "c": { "icon": true }, "o": { "click": _this.startCountdown.bind(_this) }, "a": { "href": "#" } },
                                    h("i", { "c": { "material-icons": true } }, t("camera_alt")))));
                        case Mode.UserHappy:
                            return (h("div", { "c": { "message": true } },
                                h("span", 0, _this.emotionalDescription),
                                h("span", { "c": { "arrow-icon": true } },
                                    h("i", { "c": { "material-icons": true } }, t("arrow_forward"))),
                                h("a", { "c": { "icon": true }, "o": { "click": _this.unlockContent.bind(_this) }, "a": { "href": "#" } },
                                    h("i", { "c": { "material-icons": true } }, t("lock_open")))));
                        default:
                            return;
                    }
                })()),
            h("div", { "s": { "display": this.showInactive ? "block" : "none" }, "c": { "overlay": true } }),
            h("div", { "s": { "display": this.showFlash ? "block" : "none" }, "c": { "flash": true } }),
            h("div", { "s": { "display": this.showCamera ? "block" : "none" }, "c": { "video-wrapper": true } },
                h("video", { "a": { "id": "video" } }, t("Video stream not available."))),
            h("div", { "s": { "display": this.showPicture ? "block" : "none" }, "c": { "picture-wrapper": true } },
                h("canvas", { "a": { "id": "picture" } }, t("\u00A0")))));
    };
    return SmileToUnlock;
}());
export { SmileToUnlock };
